#include <windows.h>
#include "NoDefLib.h"

//------------------------------------------------------------------------------------------------
#ifdef Use_CodeProtection_MemoryManager

static CRITICAL_SECTION ProcessCtiticalSection;
HANDLE ProcessMemoryHandle;

extern void __stdcall EnterCriticalCode()
{
	EnterCriticalSection(&ProcessCtiticalSection);
	return;
}

extern void __stdcall LeaveCriticalCode()
{
	LeaveCriticalSection(&ProcessCtiticalSection);
	return;
}

int __stdcall ShowErrorDialog()
{
	return MessageBox(0,"Out of memory. Close other applications.","Application Problem",0x52015);
}

extern LPVOID __stdcall MemAlloc(DWORD dwBytes)
{	
	LPVOID hMem;
	do{
		hMem = HeapAlloc(ProcessMemoryHandle,8,dwBytes);
	}while((!hMem)&&(ShowErrorDialog()!=2));
	return hMem;
}

extern LPVOID __stdcall MemReAlloc(void *hMem,DWORD dwBytes)
{
	if (!hMem) return MemAlloc(dwBytes);
	do{
		EnterCriticalCode();
		hMem = HeapReAlloc(ProcessMemoryHandle,8,hMem,dwBytes);
		LeaveCriticalCode();
	}while((!hMem)&&(ShowErrorDialog()!=2));
	return hMem;
}

extern BOOL __stdcall MemFree(void *hMem)
{
	return (!hMem) ? 0:HeapFree(ProcessMemoryHandle,0,hMem);
}

#endif
//------------------------------------------------------------------------------------------------

void __stdcall New_WinMain() 
{ 
	HINSTANCE hInstance = GetModuleHandle(NULL);

#ifdef Use_CodeProtection_MemoryManager
	//Initialize Error Protection In our Process
	//InitializeCriticalSection(&ProcessCtiticalSection);

	//Initialize Memory Manager for Process
	//ProcessMemoryHandle = GetProcessHeap();
#endif

	//Call Main Process Function
	WinMain(hInstance,hInstance,GetCommandLine(),SW_SHOWDEFAULT);

#ifdef Use_CodeProtection_MemoryManager
	//Delete Error Protection Information
	//DeleteCriticalSection(&ProcessCtiticalSection);
#endif

	//Exit from process
	ExitProcess(UINT(hInstance)); 
}